﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Windows.Printing;
using Telerik.Windows.Controls.TreeView;

namespace Printing
{
	public partial class MainPage : UserControl
	{
		double offsetY;
		double totalHeight;

		public MainPage()
		{
			InitializeComponent();
		}

		private void ButtonPrint_Click(object sender, RoutedEventArgs e)
		{
			this.offsetY = 0.0;
			this.totalHeight = 0.0;

			PrintDocument doc = new PrintDocument();
			doc.PrintPage += this.doc_PrintPage;
            doc.EndPrint += this.PrintEnded;
			doc.Print("RadTreeView print");
		}

        void PrintEnded(object sender, EndPrintEventArgs e)
        {
            this.treeView1.CollapseAll();
            //or rebind the tree here
        }

		void doc_PrintPage(object sender, PrintPageEventArgs e)
		{
            this.treeView1.ExpandAll();
			e.PageVisual = this.PrintGrid;

			if (this.totalHeight == 0)
			{
				this.totalHeight = this.treeView1.ScrollViewer.ExtentHeight;
			}

			this.treeView1.ScrollViewer.ScrollToVerticalOffset(this.treeView1.ScrollViewer.VerticalOffset + this.offsetY);
			this.offsetY += this.treeView1.ScrollViewer.ViewportHeight;
			e.HasMorePages = this.offsetY <= this.totalHeight;
		}

	}
}
